BEGIN TRANSACTION;
CREATE TABLE IF NOT EXISTS plan (plan_id TEXT PRIMARY KEY, solution_type INTEGER, main_site TEXT, dr_site TEXT, sync_mode INTEGER, target_id TEXT, target_type INTEGER, status INTEGER);
CREATE TABLE IF NOT EXISTS sync_info(plan_id TEXT PRIMARY KEY, sched_id INTEGER, is_send_encrypted INTEGER, is_sync_local_snapshots INTEGER, notify_time_in_min INTEGER, sync_window_enable INTEGER, sync_window TEXT, FOREIGN KEY (plan_id) REFERENCES plan (plan_id));
CREATE TABLE IF NOT EXISTS lun_replication (plan_id TEXT PRIMARY KEY, replication_id TEXT, FOREIGN KEY (plan_id) REFERENCES plan (plan_id));
CREATE TABLE IF NOT EXISTS share_replication (plan_id TEXT PRIMARY KEY, replication_id TEXT, FOREIGN KEY (plan_id) REFERENCES plan (plan_id));
CREATE TABLE IF NOT EXISTS volume_replication (plan_id TEXT PRIMARY KEY, replication_id TEXT, FOREIGN KEY (plan_id) REFERENCES plan (plan_id));
CREATE TABLE IF NOT EXISTS test_info(test_id TEXT PRIMARY KEY, plan_id TEXT, target_id TEXT, snapshot_version TEXT, create_time TEXT, FOREIGN KEY (plan_id) REFERENCES plan (plan_id));
CREATE TABLE IF NOT EXISTS remote_conn(plan_id TEXT, controller_id INTEGER, cred_id TEXT, replica_addr TEXT, replica_port INTEGER, replica_type INTEGER, PRIMARY KEY(plan_id, controller_id), FOREIGN KEY (plan_id) REFERENCES plan (plan_id));
CREATE TABLE IF NOT EXISTS db_ver (value INTEGER);
DELETE from db_ver;
INSERT INTO db_ver (value) VALUES (8);
COMMIT TRANSACTION;
