"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var WebUtil = _interopRequireWildcard(require("./webutil.js"));

var _keysym2qemuname = _interopRequireDefault(require("../core/input/syno/keysym2qemuname.js"));

var _qemuname2keycode = require("../core/input/syno/qemuname2keycode.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/* Copyright (c) 2017 Synology Inc. All rights reserved. */
var SYNO = {
  initPathSetting: function (scope, defVal) {
    // Check Query string followed by cookie
    var path = WebUtil.getConfigVar('path');
    var sharing_id = WebUtil.getConfigVar('sharing_id');

    if (path === null) {
      path = WebUtil.readSetting('path', defVal);
    }

    if (sharing_id !== null) {
      path += "?sharing_id=" + sharing_id;
    }

    scope.updateSetting('path', path);
    return path;
  },
  genModifierAndSendkey: function (sender, keysym, code, down, keyDownList) {
    if (!_keysym2qemuname.default || !_qemuname2keycode.qemuName2KeyCode || !_qemuname2keycode.allKeyboardLayout) {
      return -1;
    }

    keyDownList = keyDownList ? keyDownList : {};
    var kb_layout = WebUtil.getQueryVar("kb_layout", "en-us");
    var keysym_name = _keysym2qemuname.default[keysym];
    var keycode_arr = (0, _qemuname2keycode.qemuName2KeyCode)(kb_layout, keysym_name, keyDownList);

    if (!keycode_arr || 0 >= keycode_arr.length) {
      return -1;
    } // map modifier keycode to keysym


    var modifiers = {};

    for (var i = 1; i < keycode_arr.length; i++) {
      // Here we translate qemu_keycode name to xt_keycode name.
      // Ex: shift -> ShiftLeft
      switch (keycode_arr[i]) {
        case "shift":
          modifiers["ShiftLeft"] = {
            "keysym": 0xffe1,
            "also_check": "ShiftRight"
          };
          break;

        case "altgr":
          // altgr = alt + ctrl
          modifiers["AltRight"] = {
            "keysym": 0xffea,
            "also_check": "AltLeft"
          };

        case "ctrl":
          modifiers["ControlLeft"] = {
            "keysym": 0xffe3,
            "also_check": "ControlRight"
          };
          break;

        case "numlock":
          // We should make sure NumLock is on when seeing this key, but we don't know actual numlock state inside guest.
          // Therefore, we just do nothig here.
          break;

        default:
          break;
      }
    }

    if ("boolean" !== typeof down || true === down) {
      for (var keycode in modifiers) {
        if (modifiers.hasOwnProperty(keycode) && !(keycode in keyDownList) && !(modifiers[keycode].also_check in keyDownList)) {
          sender(modifiers[keycode].keysym, keycode, true);
        }
      }
    }

    sender(keysym, keycode_arr[0], down);

    if ("boolean" !== typeof down || false === down) {
      for (var keycode in modifiers) {
        if (modifiers.hasOwnProperty(keycode) && !(keycode in keyDownList) && !(modifiers[keycode].also_check in keyDownList)) {
          sender(modifiers[keycode].keysym, keycode, false);
        }
      }
    }

    return 0;
  }
};
var _default = SYNO;
exports.default = _default;