"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/* The naming came from qemu/ui/vnc_keysym.h.
 * We use the name to query key combination.
 */
var _default = {
  /* ascii */
  0x020: "space",
  0x021: "exclam",
  0x022: "quotedbl",
  0x023: "numbersign",
  0x024: "dollar",
  0x025: "percent",
  0x026: "ampersand",
  0x027: "apostrophe",
  0x028: "parenleft",
  0x029: "parenright",
  0x02a: "asterisk",
  0x02b: "plus",
  0x02c: "comma",
  0x02d: "minus",
  0x02e: "period",
  0x02f: "slash",
  0x030: "0",
  0x031: "1",
  0x032: "2",
  0x033: "3",
  0x034: "4",
  0x035: "5",
  0x036: "6",
  0x037: "7",
  0x038: "8",
  0x039: "9",
  0x03a: "colon",
  0x03b: "semicolon",
  0x03c: "less",
  0x03d: "equal",
  0x03e: "greater",
  0x03f: "question",
  0x040: "at",
  0x041: "A",
  0x042: "B",
  0x043: "C",
  0x044: "D",
  0x045: "E",
  0x046: "F",
  0x047: "G",
  0x048: "H",
  0x049: "I",
  0x04a: "J",
  0x04b: "K",
  0x04c: "L",
  0x04d: "M",
  0x04e: "N",
  0x04f: "O",
  0x050: "P",
  0x051: "Q",
  0x052: "R",
  0x053: "S",
  0x054: "T",
  0x055: "U",
  0x056: "V",
  0x057: "W",
  0x058: "X",
  0x059: "Y",
  0x05a: "Z",
  0x05b: "bracketleft",
  0x05c: "backslash",
  0x05d: "bracketright",
  0x05e: "asciicircum",
  0x05f: "underscore",
  0x060: "grave",
  0x061: "a",
  0x062: "b",
  0x063: "c",
  0x064: "d",
  0x065: "e",
  0x066: "f",
  0x067: "g",
  0x068: "h",
  0x069: "i",
  0x06a: "j",
  0x06b: "k",
  0x06c: "l",
  0x06d: "m",
  0x06e: "n",
  0x06f: "o",
  0x070: "p",
  0x071: "q",
  0x072: "r",
  0x073: "s",
  0x074: "t",
  0x075: "u",
  0x076: "v",
  0x077: "w",
  0x078: "x",
  0x079: "y",
  0x07a: "z",
  0x07b: "braceleft",
  0x07c: "bar",
  0x07d: "braceright",
  0x07e: "asciitilde",

  /* latin 1 extensions */
  0x0a0: "nobreakspace",
  0x0a1: "exclamdown",
  0x0a2: "cent",
  0x0a3: "sterling",
  0x0a4: "currency",
  0x0a5: "yen",
  0x0a6: "brokenbar",
  0x0a7: "section",
  0x0a8: "diaeresis",
  0x0a9: "copyright",
  0x0aa: "ordfeminine",
  0x0ab: "guillemotleft",
  0x0ac: "notsign",
  0x0ad: "hyphen",
  0x0ae: "registered",
  0x0af: "macron",
  0x0b0: "degree",
  0x0b1: "plusminus",
  0x0b2: "twosuperior",
  0x0b3: "threesuperior",
  0x0b4: "acute",
  0x0b5: "mu",
  0x0b6: "paragraph",
  0x0b7: "periodcentered",
  0x0b8: "cedilla",
  0x0b9: "onesuperior",
  0x0ba: "masculine",
  0x0bb: "guillemotright",
  0x0bc: "onequarter",
  0x0bd: "onehalf",
  0x0be: "threequarters",
  0x0bf: "questiondown",
  0x0c0: "Agrave",
  0x0c1: "Aacute",
  0x0c2: "Acircumflex",
  0x0c3: "Atilde",
  0x0c4: "Adiaeresis",
  0x0c5: "Aring",
  0x0c6: "AE",
  0x0c7: "Ccedilla",
  0x0c8: "Egrave",
  0x0c9: "Eacute",
  0x0ca: "Ecircumflex",
  0x0cb: "Ediaeresis",
  0x0cc: "Igrave",
  0x0cd: "Iacute",
  0x0ce: "Icircumflex",
  0x0cf: "Idiaeresis",
  0x0d0: "ETH",
  0x0d1: "Ntilde",
  0x0d2: "Ograve",
  0x0d3: "Oacute",
  0x0d4: "Ocircumflex",
  0x0d5: "Otilde",
  0x0d6: "Odiaeresis",
  0x0d7: "multiply",
  0x0d8: "Ooblique",
  0x0d9: "Ugrave",
  0x0da: "Uacute",
  0x0db: "Ucircumflex",
  0x0dc: "Udiaeresis",
  0x0dd: "Yacute",
  0x0de: "THORN",
  0x0df: "ssharp",
  0x0e0: "agrave",
  0x0e1: "aacute",
  0x0e2: "acircumflex",
  0x0e3: "atilde",
  0x0e4: "adiaeresis",
  0x0e5: "aring",
  0x0e6: "ae",
  0x0e7: "ccedilla",
  0x0e8: "egrave",
  0x0e9: "eacute",
  0x0ea: "ecircumflex",
  0x0eb: "ediaeresis",
  0x0ec: "igrave",
  0x0ed: "iacute",
  0x0ee: "icircumflex",
  0x0ef: "idiaeresis",
  0x0f0: "eth",
  0x0f1: "ntilde",
  0x0f2: "ograve",
  0x0f3: "oacute",
  0x0f4: "ocircumflex",
  0x0f5: "otilde",
  0x0f6: "odiaeresis",
  0x0f7: "division",
  0x0f8: "oslash",
  0x0f9: "ugrave",
  0x0fa: "uacute",
  0x0fb: "ucircumflex",
  0x0fc: "udiaeresis",
  0x0fd: "yacute",
  0x0fe: "thorn",
  0x0ff: "ydiaeresis",
  0x20ac: "EuroSign",

  /* latin 2 - Polish national characters */
  0x1ea: "eogonek",
  0x1ca: "Eogonek",
  0x1b1: "aogonek",
  0x1a1: "Aogonek",
  0x1b6: "sacute",
  0x1a6: "Sacute",
  0x1b3: "lstroke",
  0x1a3: "Lstroke",
  0x1bf: "zabovedot",
  0x1af: "Zabovedot",
  0x1bc: "zacute",
  0x1ac: "Zacute",
  0x1d5: "Odoubleacute",
  0x1db: "Udoubleacute",
  0x1e6: "cacute",
  0x1c6: "Cacute",
  0x1f1: "nacute",
  0x1d1: "Nacute",
  0x1f5: "odoubleacute",
  0x1fb: "udoubleacute",

  /* Czech national characters */
  0x1ec: "ecaron",
  0x1b9: "scaron",
  0x1e8: "ccaron",
  0x1f8: "rcaron",
  0x1be: "zcaron",
  0x1f9: "uring",

  /* modifiers */
  0xfe03: "ISO_Level3_Shift",
  0xffe3: "Control_L",
  0xffe4: "Control_R",
  0xffe9: "Alt_L",
  0xffea: "Alt_R",
  0xffe5: "Caps_Lock",
  0xffe7: "Meta_L",
  0xffe8: "Meta_R",
  0xffe1: "Shift_L",
  0xffe2: "Shift_R",
  0xffeb: "Super_L",
  0xffec: "Super_R",

  /* special keys */
  0xff08: "BackSpace",
  0xff09: "Tab",
  0xff0d: "Return",
  0xff53: "Right",
  0xff51: "Left",
  0xff52: "Up",
  0xff54: "Down",
  0xff56: "Page_Down",
  0xff55: "Page_Up",
  0xff63: "Insert",
  0xffff: "Delete",
  0xff50: "Home",
  0xff57: "End",
  0xff14: "Scroll_Lock",
  0xff95: "KP_Home",
  0xff96: "KP_Left",
  0xff97: "KP_Up",
  0xff98: "KP_Right",
  0xff99: "KP_Down",
  0xff9a: "KP_Prior",
  0xff9b: "KP_Next",
  0xff9c: "KP_End",
  0xff9d: "KP_Begin",
  0xff9e: "KP_Insert",
  0xff9f: "KP_Delete",
  0xffbe: "F1",
  0xffbf: "F2",
  0xffc0: "F3",
  0xffc1: "F4",
  0xffc2: "F5",
  0xffc3: "F6",
  0xffc4: "F7",
  0xffc5: "F8",
  0xffc6: "F9",
  0xffc7: "F10",
  0xffc8: "F11",
  0xffc9: "F12",
  0xffca: "F13",
  0xffcb: "F14",
  0xffcc: "F15",
  0xff15: "Sys_Req",
  0xffb0: "KP_0",
  0xffb1: "KP_1",
  0xffb2: "KP_2",
  0xffb3: "KP_3",
  0xffb4: "KP_4",
  0xffb5: "KP_5",
  0xffb6: "KP_6",
  0xffb7: "KP_7",
  0xffb8: "KP_8",
  0xffb9: "KP_9",
  0xffab: "KP_Add",
  0xffac: "KP_Separator",
  0xffae: "KP_Decimal",
  0xffaf: "KP_Divide",
  0xff8d: "KP_Enter",
  0xffbd: "KP_Equal",
  0xffaa: "KP_Multiply",
  0xffad: "KP_Subtract",
  0xff6a: "help",
  0xff67: "Menu",
  0xff61: "Print",
  0xff7e: "Mode_switch",
  0xff7f: "Num_Lock",
  0xff13: "Pause",
  0xff1b: "Escape",

  /* dead keys */
  0xfe50: "dead_grave",
  0xfe51: "dead_acute",
  0xfe52: "dead_circumflex",
  0xfe53: "dead_tilde",
  0xfe54: "dead_macron",
  0xfe55: "dead_breve",
  0xfe56: "dead_abovedot",
  0xfe57: "dead_diaeresis",
  0xfe58: "dead_abovering",
  0xfe59: "dead_doubleacute",
  0xfe5a: "dead_caron",
  0xfe5b: "dead_cedilla",
  0xfe5c: "dead_ogonek",
  0xfe5d: "dead_iota",
  0xfe5e: "dead_voiced_sound",
  0xfe5f: "dead_semivoiced_sound",
  0xfe60: "dead_belowdot",
  0xfe61: "dead_hook",
  0xfe62: "dead_horn",

  /* localized keys */
  0xff22: "Muhenkan",
  0xff27: "Katakana",
  0xff29: "Hankaku",
  0xff2a: "Zenkaku_Hankaku",
  0xff3e: "Henkan_Mode_Ultra",
  0xffa5: "backslash_ja",
  0xff25: "Katakana_Real",
  0xff30: "Eisu_toggle",
  0x01ff: "abovedot",
  0x03e0: "amacron",
  0x03c0: "Amacron",
  0x05d9: "Arabic_ain",
  0x05c7: "Arabic_alef",
  0x05e9: "Arabic_alefmaksura",
  0x05c8: "Arabic_beh",
  0x05ac: "Arabic_comma",
  0x05d6: "Arabic_dad",
  0x05cf: "Arabic_dal",
  0x05ef: "Arabic_damma",
  0x05ec: "Arabic_dammatan",
  0x05ee: "Arabic_fatha",
  0x05eb: "Arabic_fathatan",
  0x05e1: "Arabic_feh",
  0x05da: "Arabic_ghain",
  0x05e7: "Arabic_ha",
  0x05cd: "Arabic_hah",
  0x05c1: "Arabic_hamza",
  0x05c3: "Arabic_hamzaonalef",
  0x05c4: "Arabic_hamzaonwaw",
  0x05c6: "Arabic_hamzaonyeh",
  0x05c5: "Arabic_hamzaunderalef",
  0x05cc: "Arabic_jeem",
  0x05e3: "Arabic_kaf",
  0x05f0: "Arabic_kasra",
  0x05ed: "Arabic_kasratan",
  0x05ce: "Arabic_khah",
  0x05e4: "Arabic_lam",
  0x05c2: "Arabic_maddaonalef",
  0x05e5: "Arabic_meem",
  0x05e6: "Arabic_noon",
  0x05e2: "Arabic_qaf",
  0x05bf: "Arabic_question_mark",
  0x05d1: "Arabic_ra",
  0x05d5: "Arabic_sad",
  0x05d3: "Arabic_seen",
  0x05bb: "Arabic_semicolon",
  0x05f1: "Arabic_shadda",
  0x05d4: "Arabic_sheen",
  0x05f2: "Arabic_sukun",
  0x05d7: "Arabic_tah",
  0x05e0: "Arabic_tatweel",
  0x05ca: "Arabic_teh",
  0x05c9: "Arabic_tehmarbuta",
  0x05d0: "Arabic_thal",
  0x05cb: "Arabic_theh",
  0x05e8: "Arabic_waw",
  0x05ea: "Arabic_yeh",
  0x05d8: "Arabic_zah",
  0x05d2: "Arabic_zain",
  0x01a2: "breve",
  0x01b7: "caron",
  0x01c8: "Ccaron",
  0x06b0: "numerosign",
  0x06c1: "Cyrillic_a",
  0x06e1: "Cyrillic_A",
  0x06c2: "Cyrillic_be",
  0x06e2: "Cyrillic_BE",
  0x06de: "Cyrillic_che",
  0x06fe: "Cyrillic_CHE",
  0x06c4: "Cyrillic_de",
  0x06e4: "Cyrillic_DE",
  0x06af: "Cyrillic_dzhe",
  0x06bf: "Cyrillic_DZHE",
  0x06dc: "Cyrillic_e",
  0x06fc: "Cyrillic_E",
  0x06c6: "Cyrillic_ef",
  0x06e6: "Cyrillic_EF",
  0x06cc: "Cyrillic_el",
  0x06ec: "Cyrillic_EL",
  0x06cd: "Cyrillic_em",
  0x06ed: "Cyrillic_EM",
  0x06ce: "Cyrillic_en",
  0x06ee: "Cyrillic_EN",
  0x06d2: "Cyrillic_er",
  0x06f2: "Cyrillic_ER",
  0x06d3: "Cyrillic_es",
  0x06f3: "Cyrillic_ES",
  0x06c7: "Cyrillic_ghe",
  0x06e7: "Cyrillic_GHE",
  0x06c8: "Cyrillic_ha",
  0x06e8: "Cyrillic_HA",
  0x06df: "Cyrillic_hardsign",
  0x06ff: "Cyrillic_HARDSIGN",
  0x06c9: "Cyrillic_i",
  0x06e9: "Cyrillic_I",
  0x06c5: "Cyrillic_ie",
  0x06e5: "Cyrillic_IE",
  0x06a3: "Cyrillic_io",
  0x06b3: "Cyrillic_IO",
  0x06a8: "Cyrillic_je",
  0x06b8: "Cyrillic_JE",
  0x06cb: "Cyrillic_ka",
  0x06eb: "Cyrillic_KA",
  0x06a9: "Cyrillic_lje",
  0x06b9: "Cyrillic_LJE",
  0x06aa: "Cyrillic_nje",
  0x06ba: "Cyrillic_NJE",
  0x06cf: "Cyrillic_o",
  0x06ef: "Cyrillic_O",
  0x06d0: "Cyrillic_pe",
  0x06f0: "Cyrillic_PE",
  0x06db: "Cyrillic_sha",
  0x06fb: "Cyrillic_SHA",
  0x06dd: "Cyrillic_shcha",
  0x06fd: "Cyrillic_SHCHA",
  0x06ca: "Cyrillic_shorti",
  0x06ea: "Cyrillic_SHORTI",
  0x06d8: "Cyrillic_softsign",
  0x06f8: "Cyrillic_SOFTSIGN",
  0x06d4: "Cyrillic_te",
  0x06f4: "Cyrillic_TE",
  0x06c3: "Cyrillic_tse",
  0x06e3: "Cyrillic_TSE",
  0x06d5: "Cyrillic_u",
  0x06f5: "Cyrillic_U",
  0x06d7: "Cyrillic_ve",
  0x06f7: "Cyrillic_VE",
  0x06d1: "Cyrillic_ya",
  0x06f1: "Cyrillic_YA",
  0x06d9: "Cyrillic_yeru",
  0x06f9: "Cyrillic_YERU",
  0x06c0: "Cyrillic_yu",
  0x06e0: "Cyrillic_YU",
  0x06da: "Cyrillic_ze",
  0x06fa: "Cyrillic_ZE",
  0x06d6: "Cyrillic_zhe",
  0x06f6: "Cyrillic_ZHE",
  0x01bd: "doubleacute",
  0x0afe: "doublelowquotemark",
  0x08fe: "downarrow",
  0x01f0: "dstroke",
  0x01d0: "Dstroke",
  0x03ec: "eabovedot",
  0x03cc: "Eabovedot",
  0x03ba: "emacron",
  0x03aa: "Emacron",
  0x0aaa: "endash",
  0x03bf: "eng",
  0x03bd: "ENG",
  0xff62: "Execute",
  0xffcd: "F16",
  0xffce: "F17",
  0xffcf: "F18",
  0xffd0: "F19",
  0xffd1: "F20",
  0xffd2: "F21",
  0xffd3: "F22",
  0xffd4: "F23",
  0xffd5: "F24",
  0xffd6: "F25",
  0xffd7: "F26",
  0xffd8: "F27",
  0xffd9: "F28",
  0xffda: "F29",
  0xffdb: "F30",
  0xffdc: "F31",
  0xffdd: "F32",
  0xffde: "F33",
  0xffdf: "F34",
  0xffe0: "F35",
  0x0ac5: "fiveeighths",
  0x02bb: "gbreve",
  0x02ab: "Gbreve",
  0x03bb: "gcedilla",
  0x03ab: "Gcedilla",
  0x07d9: "Greek_OMEGA",
  0xff23: "Henkan_Mode",
  0x08a3: "horizconnector",
  0x02b1: "hstroke",
  0x02a1: "Hstroke",
  0x02a9: "Iabovedot",
  0x02b9: "idotless",
  0x03ef: "imacron",
  0x03cf: "Imacron",
  0x03e7: "iogonek",
  0x03c7: "Iogonek",
  0xfe0c: "ISO_First_Group",
  0xfe0e: "ISO_Last_Group",
  0xfe08: "ISO_Next_Group",
  0x04a7: "kana_a",
  0x04b1: "kana_A",
  0x04c1: "kana_CHI",
  0x04a3: "kana_closingbracket",
  0x04a4: "kana_comma",
  0x04a5: "kana_conjunctive",
  0x04aa: "kana_e",
  0x04b4: "kana_E",
  0x04cc: "kana_FU",
  0x04a1: "kana_fullstop",
  0x04ca: "kana_HA",
  0x04cd: "kana_HE",
  0x04cb: "kana_HI",
  0x04ce: "kana_HO",
  0x04a8: "kana_i",
  0x04b2: "kana_I",
  0x04b6: "kana_KA",
  0x04b9: "kana_KE",
  0x04b7: "kana_KI",
  0x04ba: "kana_KO",
  0x04b8: "kana_KU",
  0x04cf: "kana_MA",
  0x04d2: "kana_ME",
  0x04d0: "kana_MI",
  0x04d3: "kana_MO",
  0x04d1: "kana_MU",
  0x04dd: "kana_N",
  0x04c5: "kana_NA",
  0x04c8: "kana_NE",
  0x04c6: "kana_NI",
  0x04c9: "kana_NO",
  0x04c7: "kana_NU",
  0x04ab: "kana_o",
  0x04b5: "kana_O",
  0x04a2: "kana_openingbracket",
  0x04d7: "kana_RA",
  0x04da: "kana_RE",
  0x04d8: "kana_RI",
  0x04d9: "kana_RU",
  0x04bb: "kana_SA",
  0x04be: "kana_SE",
  0x04bc: "kana_SHI",
  0x04bf: "kana_SO",
  0x04bd: "kana_SU",
  0x04c0: "kana_TA",
  0x04c3: "kana_TE",
  0x04c4: "kana_TO",
  0x04af: "kana_tsu",
  0x04c2: "kana_TSU",
  0x04a9: "kana_u",
  0x04b3: "kana_U",
  0x04dc: "kana_WA",
  0x04a6: "kana_WO",
  0x04ac: "kana_ya",
  0x04d4: "kana_YA",
  0x04ae: "kana_yo",
  0x04d6: "kana_YO",
  0x04ad: "kana_yu",
  0x04d5: "kana_YU",
  0xff21: "Kanji",
  0x03f3: "kcedilla",
  0x03d3: "Kcedilla",
  0x03a2: "kra",
  0x03b6: "lcedilla",
  0x03a6: "Lcedilla",
  0x08fb: "leftarrow",
  0x0ad2: "leftdoublequotemark",
  0x06a5: "Macedonia_dse",
  0x06b5: "Macedonia_DSE",
  0x06a2: "Macedonia_gje",
  0x06b2: "Macedonia_GJE",
  0x06ac: "Macedonia_kje",
  0x06bc: "Macedonia_KJE",
  0x03f1: "ncedilla",
  0x03d1: "Ncedilla",
  0x13bd: "oe",
  0x13bc: "OE",
  0x01b2: "ogonek",
  0x03f2: "omacron",
  0x03d2: "Omacron",
  0x0ac3: "oneeighth",
  0x03b3: "rcedilla",
  0x03a3: "Rcedilla",
  0x08fd: "rightarrow",
  0x0ad3: "rightdoublequotemark",
  0x01a9: "Scaron",
  0x01ba: "scedilla",
  0x01aa: "Scedilla",
  0x04df: "semivoicedsound",
  0x0ac6: "seveneighths",
  0x0ddf: "Thai_baht",
  0x0dba: "Thai_bobaimai",
  0x0da8: "Thai_chochan",
  0x0daa: "Thai_chochang",
  0x0da9: "Thai_choching",
  0x0dac: "Thai_chochoe",
  0x0dae: "Thai_dochada",
  0x0db4: "Thai_dodek",
  0x0dbd: "Thai_fofa",
  0x0dbf: "Thai_fofan",
  0x0dcb: "Thai_hohip",
  0x0dce: "Thai_honokhuk",
  0x0da2: "Thai_khokhai",
  0x0da5: "Thai_khokhon",
  0x0da3: "Thai_khokhuat",
  0x0da4: "Thai_khokhwai",
  0x0da6: "Thai_khorakhang",
  0x0da1: "Thai_kokai",
  0x0de5: "Thai_lakkhangyao",
  0x0df7: "Thai_lekchet",
  0x0df5: "Thai_lekha",
  0x0df6: "Thai_lekhok",
  0x0df9: "Thai_lekkao",
  0x0df1: "Thai_leknung",
  0x0df8: "Thai_lekpaet",
  0x0df3: "Thai_leksam",
  0x0df4: "Thai_leksi",
  0x0df2: "Thai_leksong",
  0x0df0: "Thai_leksun",
  0x0dcc: "Thai_lochula",
  0x0dc5: "Thai_loling",
  0x0dc6: "Thai_lu",
  0x0deb: "Thai_maichattawa",
  0x0de8: "Thai_maiek",
  0x0dd1: "Thai_maihanakat",
  0x0de7: "Thai_maitaikhu",
  0x0de9: "Thai_maitho",
  0x0dea: "Thai_maitri",
  0x0de6: "Thai_maiyamok",
  0x0dc1: "Thai_moma",
  0x0da7: "Thai_ngongu",
  0x0ded: "Thai_nikhahit",
  0x0db3: "Thai_nonen",
  0x0db9: "Thai_nonu",
  0x0dcd: "Thai_oang",
  0x0dcf: "Thai_paiyannoi",
  0x0dda: "Thai_phinthu",
  0x0dbe: "Thai_phophan",
  0x0dbc: "Thai_phophung",
  0x0dc0: "Thai_phosamphao",
  0x0dbb: "Thai_popla",
  0x0dc3: "Thai_rorua",
  0x0dc4: "Thai_ru",
  0x0dd0: "Thai_saraa",
  0x0dd2: "Thai_saraaa",
  0x0de1: "Thai_saraae",
  0x0de4: "Thai_saraaimaimalai",
  0x0de3: "Thai_saraaimaimuan",
  0x0dd3: "Thai_saraam",
  0x0de0: "Thai_sarae",
  0x0dd4: "Thai_sarai",
  0x0dd5: "Thai_saraii",
  0x0de2: "Thai_sarao",
  0x0dd8: "Thai_sarau",
  0x0dd6: "Thai_saraue",
  0x0dd7: "Thai_sarauee",
  0x0dd9: "Thai_sarauu",
  0x0dc9: "Thai_sorusi",
  0x0dc8: "Thai_sosala",
  0x0dab: "Thai_soso",
  0x0dca: "Thai_sosua",
  0x0dec: "Thai_thanthakhat",
  0x0db1: "Thai_thonangmontho",
  0x0db2: "Thai_thophuthao",
  0x0db7: "Thai_thothahan",
  0x0db0: "Thai_thothan",
  0x0db8: "Thai_thothong",
  0x0db6: "Thai_thothung",
  0x0daf: "Thai_topatak",
  0x0db5: "Thai_totao",
  0x0dc7: "Thai_wowaen",
  0x0dc2: "Thai_yoyak",
  0x0dad: "Thai_yoying",
  0x0ac4: "threeeighths",
  0x0ac9: "trademark",
  0x03bc: "tslash",
  0x03ac: "Tslash",
  0x03fe: "umacron",
  0x03de: "Umacron",
  0x03f9: "uogonek",
  0x03d9: "Uogonek",
  0x08fc: "uparrow",
  0x04de: "voicedsound",
  0x01ae: "Zcaron"
};
exports.default = _default;