#!/bin/bash
# Copyright (c) 2016-2018 Synology Inc. All rights reserved.

TYPE="$1"
MASTER="$2"
SLAVES="$3"
Use_DHCP="$4"
IP="$5"
Netmask="$6"
manageIf=""
manageIp=""

check() {
	hasClusterIf="no"

	if [ "yes" != "`/bin/get_key_value /usr/syno/etc/ccc/cccinfo.conf runccc`" ]; then
		logger -t synoccc -p err "runccc not enabled, skip feasibility check"
		return 0
	fi

	manageIf=`/bin/get_key_value /usr/syno/etc/ccc/local.webapi.conn.info management_if`
	if [ -z "${manageIf}" ]; then
		logger -t synoccc -p err "No management_if"
		return 1
	fi

	slaves=("${SLAVES//,/ }")
	for slave in $slaves; do
		if [ "ovs_${manageIf}" == "${slave}" ]; then
			hasClusterIf="yes"
		fi
	done

	if [ "${hasClusterIf}" == "no" ]; then
		logger -t synoccc -p err "Has no cluster interface"
		return 0
	fi

	manageIp=`/bin/get_key_value /usr/syno/etc/ccc/local.webapi.conn.info management_ip`
	if [ -z "${manageIp}" ]; then
		logger -t synoccc -p err "No management_ip"
		return 1
	fi

	if [ "${Use_DHCP}" == "true" ]; then
		logger -t synoccc -p err "Cannot change cluster interface to dhcp"
		return 1
	fi

	if [ "${manageIp}" != "${IP}" ]; then
		logger -t synoccc -p err "Cannot change cluster interface ip."
		return 1
	fi
	return 0
}

check
if [ $? -ne 0 ]; then
	if [ -z "$manageIf" || -z "$manageIp" ]; then
		exit 1
	fi
	mask=`ifconfig ovs_${manageIf}| grep Mask| cut -d ':' -f 4`
	echo "${manageIp}|${mask}"
	exit 1
else
	exit 0
fi
