#!/bin/sh
# Copyright (c) 2018 Synology Inc. All rights reserved.

INTERFACE="$1"
DHCP_ENABLE="$2"

if [ "yes" != "`/bin/get_key_value /usr/syno/etc/ccc/cccinfo.conf runccc`" ]; then
	logger -t synoccc -p err "runccc not enabled, skip dhcp feasibility check"
	exit 0
fi

CLUSTER_INTERFACE=`/bin/get_key_value /usr/syno/etc/ccc/local.webapi.conn.info management_if`
if [ -z "${CLUSTER_INTERFACE}" ]; then
	logger -t synoccc -p err "No cluster interface"
	exit 0
fi

if [ "ovs_${CLUSTER_INTERFACE}" != ${INTERFACE} ]; then
	logger -t synoccc -p err "Interface ${INTERFACE} not matched cluster interface ovs_${CLUSTER_INTERFACE}"
	exit 0
fi

if [ "${DHCP_ENABLE}" == "false" ]; then
	logger -t synoccc -p err "Interface not using dhcp"
	exit 0
fi

exit 1
