#!/bin/bash
# Copyright (c) 2018 Synology Inc. All rights reserved.

SYNOCCCTOOL_BINARY=/var/packages/Virtualization/target/bin/synoccctool

if [[ $@ == *"Virtualization"* ]]; then
	package_name="Virtualization"
elif [[ $@ == *"ReplicationService"* ]]; then
	package_name="ReplicationService"
else
	exit 0
fi

if ! synopkg status Virtualization; then
	logger -p user.warn -t synoccc "Skip $package_name package install feasibility check."
	exit 0
fi

if [ -e ${SYNOCCCTOOL_BINARY} ]; then
	$SYNOCCCTOOL_BINARY --vmm-install-pkg $package_name || exit 1
fi
exit 0
