#!/bin/sh
# Copyright (c) 2017 Synology Inc. All rights reserved.

SYNOCCCTOOL_BINARY="/var/packages/Virtualization/target/bin/synoccctool"

SYNOCCC_PKG_NAME="Syno.CCC"
SYNOCCC_PKG_VERSION="1.0"
SYNOCCC_PKG_VENDOR="Synology Inc."
SYNOCCC_PKG_MODVER="1.0"

case $1 in
	--sdk-mod-ver)
		echo ${SYNOCCC_PKG_MODVER}
	;;
	--name)
		echo ${SYNOCCC_PKG_NAME}
	;;
	--pkg-ver)
		echo ${SYNOCCC_PKG_VERSION}
	;;
	--vendor)
		echo ${SYNOCCC_PKG_VENDOR}
	;;
	--pre)
		if ! synopkg status Virtualization; then
			logger -p user.warn -t synoccc "Skip Virtualization account logout hook."
			exit 0
		fi
		if [ -x "${SYNOCCCTOOL_BINARY}" ]; then
			logger -p user.warn -t synoccc "[Logout MyDS Account] Remove account info in Virtualization dashboard."
			${SYNOCCCTOOL_BINARY} --logout-synology-account
		fi
	;;
	*)
		echo "Usage: $0 --sdk-mod-ver|--name|--pkg-ver|--vendor|--pre"
	;;
esac

