#!/bin/bash
# Copyright (c) 2016-2018 Synology Inc. All rights reserved.

SYNOCCCTOOL_BINARY=/var/packages/Virtualization/target/bin/synoccctool

SYNOCCC_PKG_NAME="Syno.CCC"
SYNOCCC_PKG_VERSION="1.0"
SYNOCCC_PKG_VENDOR="Synology Inc."
SYNOCCC_PKG_MODVER="1.0"

case $1 in
	--sdk-mod-ver)
		echo ${SYNOCCC_PKG_MODVER}
	;;
	--name)
		echo ${SYNOCCC_PKG_NAME}
	;;
	--pkg-ver)
		echo ${SYNOCCC_PKG_VERSION}
	;;
	--vendor)
		echo ${SYNOCCC_PKG_VENDOR}
	;;
	--pre)
		if ! synopkg status Virtualization; then
			exit 0
		fi
		${SYNOCCCTOOL_BINARY} --host-nic-busy-set "true"
		if [ "${TYPE}" = "ovs" ]; then
			${SYNOCCCTOOL_BINARY} --bond-change-pre ${ACTION} ${MASTER} ${SLAVES}
		fi
	;;
	--post)
		if ! synopkg status Virtualization; then
			exit 0
		fi
		${SYNOCCCTOOL_BINARY} --update-management-if
		${SYNOCCCTOOL_BINARY} --host-nic-busy-set "false"
		if [ "${TYPE}" = "ovs" ]; then
			${SYNOCCCTOOL_BINARY} --bond-change-post ${ACTION} ${MASTER} ${SLAVES}
		fi
	;;
	*)
		echo "Usage: $0 --sdk-mod-ver|--name|--pkg-ver|--vendor|--pre|--post"
	;;
esac
