#!/bin/bash
# Copyright (c) 2016-2018 Synology Inc. All rights reserved.

SYNOCCCTOOL_BINARY=/var/packages/Virtualization/target/bin/synoccctool

SYNOCCC_PKG_NAME="Syno.CCC"
SYNOCCC_PKG_VERSION="1.0"
SYNOCCC_PKG_VENDOR="Synology Inc."
SYNOCCC_PKG_MODVER="1.0"

case $1 in
	--sdk-mod-ver)
		echo ${SYNOCCC_PKG_MODVER}
	;;
	--name)
		echo ${SYNOCCC_PKG_NAME}
	;;
	--pkg-ver)
		echo ${SYNOCCC_PKG_VERSION}
	;;
	--vendor)
		echo ${SYNOCCC_PKG_VENDOR}
	;;
	--pre)
	;;
	--post)
		if ! synopkg status Virtualization; then
			exit 0
		fi
		##If the openvswitch exists, we need to add the prefix ovs_ to the IFNAME
		if [ -d "/sys/devices/virtual/net/ovs_${IFNAME}" ]; then
			IFNAME="ovs_${IFNAME}"
		fi
		if [ -e ${SYNOCCCTOOL_BINARY} ]; then
			${SYNOCCCTOOL_BINARY} --link-up ${IFNAME}
		fi
	;;
	*)
		echo "Usage: $0 --sdk-mod-ver|--name|--pkg-ver|--vendor|--pre|--post"
	;;
esac

