#!/bin/sh
# Copyright (c) 2016 Synology Inc. All rights reserved.

SYNOCCCTOOL_BINARY="/var/packages/Virtualization/target/bin/synoccctool"
SYNOCCCGUEST="/var/packages/Virtualization/target/bin/synocccguest"
PKG_UTILS="/var/packages/Virtualization/scripts/pkg_utils"

SYNOCCC_PKG_NAME="Syno.CCC"
SYNOCCC_PKG_VERSION="1.0"
SYNOCCC_PKG_VENDOR="Synology Inc."
SYNOCCC_PKG_MODVER="1.0"

case $1 in
	--sdk-mod-ver)
		echo ${SYNOCCC_PKG_MODVER}
	;;
	--name)
		echo ${SYNOCCC_PKG_NAME}
	;;
	--pkg-ver)
		echo ${SYNOCCC_PKG_VERSION}
	;;
	--vendor)
		echo ${SYNOCCC_PKG_VENDOR}
	;;
	--pre)
		# User can not disable OVS by AdminCenter/Network when Virtualization enabled,
		# but only can by Reset Button
		if [ "delete" == "$ACTION" ]; then
			if ! synopkg status Virtualization; then
				. $PKG_UTILS
				ForceRemoveCluster
				exit 0
			fi
			if [ -x "$SYNOCCCGUEST" ]; then
				/bin/logger -p err "$0: Virtualization start to shutdown guests"
				$SYNOCCCGUEST -S
				/bin/logger -p err "$0: Virtualization shutdown guests done."
			fi
			if [ -x "$SYNOCCCTOOL_BINARY" ]; then
				$SYNOCCCTOOL_BINARY --force-remove-cluster
			fi
		fi
	;;
	--post)
	;;
	*)
		echo "Usage: $0 --sdk-mod-ver|--name|--pkg-ver|--vendor|--pre|--post"
	;;
esac

