#!/bin/sh
# Copyright (c) 2016 Synology Inc. All rights reserved.

SYNOCCCTOOL_BINARY="/var/packages/Virtualization/target/bin/synoccctool"
SYNOCCCGUEST="/var/packages/Virtualization/target/bin/synocccguest"
QC_DUMP_GUEST_STATE_FLAG="/tmp/.dump_guest_states_on_shutdown"
GUEST_STATE_DUMP_PATH="/root/all_guest_states.dump"

SYNOCCC_PKG_NAME="Syno.CCC"
SYNOCCC_PKG_VERSION="1.0"
SYNOCCC_PKG_VENDOR="Synology Inc."
SYNOCCC_PKG_MODVER="1.0"

case $1 in
	--sdk-mod-ver)
		echo ${SYNOCCC_PKG_MODVER}
	;;
	--name)
		echo ${SYNOCCC_PKG_NAME}
	;;
	--pkg-ver)
		echo ${SYNOCCC_PKG_VERSION}
	;;
	--vendor)
		echo ${SYNOCCC_PKG_VENDOR}
	;;
	--pre)
		if ! synopkg status Virtualization; then
			exit 0
		fi
		ETCD_STATE=
		if [ -f "${SYNOCCCTOOL_BINARY}" ]; then
			ETCD_STATE="$($SYNOCCCTOOL_BINARY --get-etcd-state)"
		fi

		# "disabled" means Virt package disabled(eg. upgrade DSM)
		if [ "disabled" != "$ETCD_STATE" ]; then
			${SYNOCCCTOOL_BINARY} --pkg-stop-log
			if [ -f ${SYNOCCCGUEST} ]; then
				/bin/logger -p err "$0: Start to shutdown guests"
				$SYNOCCCGUEST -S -r host_shutdown
				/bin/logger -p err "$0: Done."
				if [ -e "$QC_DUMP_GUEST_STATE_FLAG" ]; then
					$SYNOCCCGUEST -l > $GUEST_STATE_DUMP_PATH
				fi
			fi
			${SYNOCCCTOOL_BINARY} --host-offline
		fi
	;;
	--post)
	;;
	*)
		echo "Usage: $0 --sdk-mod-ver|--name|--pkg-ver|--vendor|--pre|--post"
	;;
esac

exit 0
