#!/bin/sh
# Copyright (c) 2019 Synology Inc. All rights reserved.

SYNOCCCTOOL_BINARY="/var/packages/Virtualization/target/bin/synoccctool"

SYNOCCC_PKG_NAME="Syno.CCC"
SYNOCCC_PKG_VERSION="1.0"
SYNOCCC_PKG_VENDOR="Synology Inc."
SYNOCCC_PKG_MODVER="1.0"

case $1 in
	--sdk-mod-ver)
		echo ${SYNOCCC_PKG_MODVER}
	;;
	--name)
		echo ${SYNOCCC_PKG_NAME}
	;;
	--pkg-ver)
		echo ${SYNOCCC_PKG_VERSION}
	;;
	--vendor)
		echo ${SYNOCCC_PKG_VENDOR}
	;;
	--pre)
	;;
	--post)
		/bin/logger -p err "$0: sha activate post hook, bind license group ..."
		if [ -x "${SYNOCCCTOOL_BINARY}" ]; then
			${SYNOCCCTOOL_BINARY} --license-group-sha-bind
		fi
	;;
	*)
		echo "Usage: $0 --sdk-mod-ver|--name|--pkg-ver|--vendor|--pre|--post"
	;;
esac

exit 0
