#!/bin/sh
# Copyright (c) 2019 Synology Inc. All rights reserved.

SYNOCCCTOOL_BINARY="/var/packages/Virtualization/target/bin/synoccctool"

SYNOCCC_PKG_NAME="Syno.CCC"
SYNOCCC_PKG_VERSION="1.0"
SYNOCCC_PKG_VENDOR="Synology Inc."
SYNOCCC_PKG_MODVER="1.0"

case $1 in
	--sdk-mod-ver)
		echo ${SYNOCCC_PKG_MODVER}
	;;
	--name)
		echo ${SYNOCCC_PKG_NAME}
	;;
	--pkg-ver)
		echo ${SYNOCCC_PKG_VERSION}
	;;
	--vendor)
		echo ${SYNOCCC_PKG_VENDOR}
	;;
	--pre)
		/bin/logger -p err "$0: sha deactivate pre hook, stop Virtualization ..."

		synopkg stop Virtualization

		/bin/logger -p err "$0: sha deactivate pre hook, Virtualization stoped"

		if [ "yes" == "`synogetkeyvalue /usr/syno/etc/ccc/cccinfo.conf runccc`" ]; then
			/bin/logger -p err "$0: sha deactivate pre hook, remove run key"
			synosetkeyvalue /usr/syno/etc/ccc/cccinfo.conf runccc no
		fi

		/bin/logger -p err "$0: sha deactivate pre hook Virtualization done"
	;;
	--post)
	;;
	*)
		echo "Usage: $0 --sdk-mod-ver|--name|--pkg-ver|--vendor|--pre|--post"
	;;
esac

exit 0
